package com.company.chartsaddon.view.series.funnelseries;


import com.company.chartsaddon.view.main.MainView;
import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import io.jmix.chartsflowui.component.Chart;
import io.jmix.chartsflowui.kit.component.model.shared.Color;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.view.*;

import java.util.ArrayList;
import java.util.Random;

@Route(value = "FunnelSeries", layout = MainView.class)
@ViewController("FunnelSeriesView")
@ViewDescriptor("funnel-series-view.xml")
public class FunnelSeriesView extends StandardView {

    protected static Random random = new Random();
    @ViewComponent
    private Chart chart;

    @Subscribe(id = "randomPaletteBtn", subject = "clickListener")
    public void onRandomPaletteBtnClick(final ClickEvent<JmixButton> event) {
        chart.clearColorPalette();
        ArrayList<String> strings = new ArrayList<>();
        for (int i = 0; i < 9; ++i) {
            strings.add("#" + Integer.toHexString(random.nextInt() * 100));
        }

        chart.setColorPalette(strings.stream().map(Color::valueOf).toArray(Color[]::new));
    }
}