package com.company.chartsaddon.view.series.radarseries;

import com.company.chartsaddon.view.main.MainView;
import com.vaadin.flow.router.Route;
import io.jmix.chartsflowui.component.Chart;
import io.jmix.chartsflowui.data.item.MapDataItem;
import io.jmix.chartsflowui.kit.component.model.DataSet;
import io.jmix.chartsflowui.kit.data.chart.ListChartItems;
import io.jmix.flowui.view.*;

import java.util.Map;

@Route(value = "RadarSeries", layout = MainView.class)
@ViewController("RadarSeriesView")
@ViewDescriptor("radar-series-view.xml")
public class RadarSeriesView extends StandardView {

    @ViewComponent
    protected Chart chart;

    @Subscribe
    protected void onInit(InitEvent event) {
        chart.addDoubleClickEventListener(__ ->
        {
            chart.getElement().executeJs("""
                $0._root.setOption({
                                         xAxis: {
                                           type: 'category',
                                           data: ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
                                         },
                                         yAxis: {
                                           type: 'value'
                                         },
                                         series: [
                                           {
                                             data: [150, 230, 224, 218, 135, 147, 260],
                                             type: 'line'
                                           }
                                         ]
                                       },true);
                """);
        });
    }
}